#ifndef MESH_H_
#define MESH_H_

#include "vec.h"
#include "sphere.h"

class Mesh {
private:
	int vcount;
	Vector3 *vertices;
	Vector3 *normals;

	Vector3 pos;

public:
	Mesh();
	~Mesh();

	void set_position(float x, float y, float z);

	bool load(const char *fname);

	void draw() const;
	void draw_bsph() const;

	bool intersect(const Ray &ray, HitPoint *pt) const;
};

#endif	// MESH_H_
