#ifndef SPHERE_H_
#define SPHERE_H_

#include "vec.h"
#include "ray.h"

struct HitPoint {
	float dist;        // parametric distance of intersection along the ray
	Vector3 pos;       // world position of the intersection point
	Vector3 normal;    // surface normal vector at the intersection point
};

class Sphere {
public:
	Vector3 pos;
	float radius;

	Sphere();
	Sphere(const Vector3 &pos, float rad);

	bool intersect(const Ray &ray, HitPoint *pt) const;
};

#endif	// SPHERE_H_
